//-----------------------------------------------------------------------------
// blend.h : uh
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#pragma once

#include "sysdep.h"

#ifdef __cplusplus
extern "C" {
#endif

NOA void disp_motion(PIXEL_YC * restrict dst,
                     const short * restrict mv0, const short * restrict mv1,
                     int mode, int h, int w, int s);

NOA void blend_image(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                     const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_min(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_max(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w);

NOA void blend_image_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_min_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                             const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_max_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                             const short * restrict mv0, const short * restrict mv1, int w);

NOA void blend_image_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                          const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_min_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w);
NOA void blend_image_max_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w);

typedef void (*BLEND_IMG)(PIXEL_YC * restrict, const PIXEL_YC * restrict,
                          const short * restrict, const short * restrict, int);

#ifdef __cplusplus
}
#endif

